public class Line {
  float drawWidth;
  PVector startPos;
  float drawAngle;
  color drawCol;
  
  PVector lastStartPos;
  float lastDrawAngle;
  boolean curDraw;
  
  public Line(PVector startPosi, float drawAnglei, color drawColi, float drawWidthi) {
    startPos = startPosi;
    drawAngle = drawAnglei;
    drawCol = drawColi;
    drawWidth = drawWidthi;
    curDraw = false;
    
    lastStartPos = new PVector(0, 0);
    lastDrawAngle = 0;
  }
  
  public double Draw() {
    if(!curDraw) {
      lastStartPos.set(startPos);
      lastDrawAngle = drawAngle; 
      curDraw = true;
      return 0;
    }
    /*
    stroke(drawCol);
    strokeWeight(drawWidth);
    */
    
    fill(drawCol);
    
    //a quad is drawn with corners startPos, lastStartPos, startPos + drawAngle*length, lastStartPos + lastDrawAngle*length
    PVector finishPos = new PVector(startPos.x + drawLength * cos(drawAngle), startPos.y + drawLength * sin(drawAngle));
    PVector lastFinishPos = new PVector(lastStartPos.x + drawLength * cos(lastDrawAngle), lastStartPos.y + drawLength * sin(lastDrawAngle));
    PVector finishPos2 = new PVector(finishPos.x + 5000 * cos(drawAngle), finishPos.y + 5000 * sin(drawAngle));
    PVector lastFinishPos2 = new PVector(lastFinishPos.x + drawLength * cos(lastDrawAngle), lastFinishPos.y + drawLength * sin(lastDrawAngle));
    
    stroke(hue(drawCol), saturation(drawCol), brightness(drawCol), alpha(drawCol) * 1.7);
    line(startPos.x, startPos.y, finishPos.x, finishPos.y);
    
    stroke(hue(drawCol), saturation(drawCol), brightness(drawCol), alpha(drawCol) * 1);
    //line(finishPos.x, finishPos.y, finishPos2.x, finishPos2.y);
    
    noStroke();
    quad(startPos.x, startPos.y, lastStartPos.x, lastStartPos.y, lastFinishPos.x, lastFinishPos.y, finishPos.x, finishPos.y);
    
    fill(hue(drawCol), saturation(drawCol), brightness(drawCol), alpha(drawCol) / 2.0);
    //quad(lastFinishPos.x, lastFinishPos.y, finishPos.x, finishPos.y, finishPos2.x, finishPos2.y, lastFinishPos2.x, lastFinishPos2.y);
    
    float a1 = PVector.sub(finishPos, startPos).mag();
    float b1 = PVector.sub(startPos, lastStartPos).mag();
    float c1 = PVector.sub(finishPos, lastStartPos).mag();
    float s1 = (a1 + b1 + c1)/2;
    float area1 = sqrt(s1 * (s1 - a1) * (s1 - b1) * (s1 - c1));
    
    float a2 = PVector.sub(lastFinishPos, lastStartPos).mag();
    float b2 = PVector.sub(lastFinishPos, finishPos).mag();
    float c2 = PVector.sub(finishPos, lastStartPos).mag();
    float s2 = (a2 + b2 + c2) / 2;
    float area2 = sqrt(s2 * (s2 - a2) * (s2 - b2) * (s2 - c2));
    
    lastStartPos.set(startPos);
    lastDrawAngle = drawAngle; 
    
    return (area1 + area2);
    /*
    
    //a line is drawn from startPos along direction defined by drawAngle
    PVector finishPos = new PVector(startPos.x + drawLength * cos(drawAngle), startPos.y + drawLength * sin(drawAngle));
    line(startPos.x, startPos.y, finishPos.x, finishPos.y);
    
    PVector finishPosSecond = new PVector(finishPos.x + drawLength * cos(drawAngle), finishPos.y + drawLength * sin(drawAngle));
    stroke(hue(drawCol), saturation(drawCol), brightness(drawCol), alpha(drawCol) / 2.0);
    line(finishPos.x, finishPos.y, finishPosSecond.x, finishPosSecond.y);
    
    PVector finishPosThird = new PVector(finishPosSecond.x + drawLength * cos(drawAngle), finishPosSecond.y + drawLength * sin(drawAngle));
    stroke(hue(drawCol), saturation(drawCol), brightness(drawCol), alpha(drawCol) / 2.0);
    line(finishPos.x, finishPos.y, finishPosThird.x, finishPosThird.y);
    
    PVector finishPosFourth = new PVector(finishPosSecond.x + 1000000 * cos(drawAngle), finishPosSecond.y + 1000000 * sin(drawAngle));
    stroke(hue(drawCol), saturation(drawCol), brightness(drawCol), alpha(drawCol) / 2.0);
    line(finishPos.x, finishPos.y, finishPosFourth.x, finishPosFourth.y);
    
    */
  }
}
